/*
 * ${license.title}
 * Copyright (C) 2022 ${license.owner}
 * ${license.mailto}
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#include "fggl/data/storage.hpp"
#include "fggl/audio/audio.hpp"

#include "../stb/stb_vorbis.h"

namespace fggl::audio {


} // namespace fggl::audio

namespace fggl::data {

	template<>
	bool fggl_deserialize<audio::AudioClip>(std::filesystem::path &data, audio::AudioClip* out) {
		out->sampleCount = stb_vorbis_decode_filename(data.c_str(),
													 &out->channels,
													 &out->sampleRate,
													 &out->data);
		return out->sampleCount != -1;
	}

} // namespace fggl::data